/* SCCSID = "%W% %E%" */
/****************************************************************************/
/*                                                                          */
/*                           IBM Confidential                               */
/*                                                                          */
/*                 Copyright (c) IBM Corporation 1996                       */
/*                           All Rights Reserved                            */
/*                                                                          */
/****************************************************************************/
/************************** START OF SPECIFICATIONS ***************************/
/*                                                                            */
/*   SOURCE FILE NAME:  PAR.H                                                 */
/*                                                                            */
/*   DESCRIPTIVE NAME:  PARALLEL port device driver master include file.      */
/*                                                                            */
/*   FUNCTION: This module is the PARALLEL port device driver master          */
/*             include file.                                                  */
/*                                                                            */
/*   NOTES:                                                                   */
/*      DEPENDENCIES: None                                                    */
/*      RESTRICTIONS: None                                                    */
/*                                                                            */
/*   ENTRY POINTS:  None                                                      */
/*                                                                            */
/*   EXTERNAL REFERENCES:  None                                               */
/*                                                                            */
/* Change Log                                                                 */
/*                                                                            */
/*  Mark    yy/mm/dd  Programmer      Comment                                 */
/*  ----    --------  ----------      -------                                 */
/*          96/03/01  Frank Schroeder                                         */
/*                                                                            */
/**************************** END OF SPECIFICATIONS ***************************/

#define INCL_NOBASEAPI
#define INCL_NOPMAPI
#define INCL_ERRORS

#include <os2.h>              /* special types  includes os2defs.h */
#include <bseerr.h>           /* error definitions */

#include <devhdr.h>           /* device driver header definitions */
#include <devcmd.h>           /* device driver strategy commands */
#include <strat2.h>           /* defines P_DriverCaps for reqpkt.h. */
#include <reqpkt.h>           /* request packet structure definitions */
#include <dhcalls.h>          /* device helper calls */
#include <rmcalls.h>          /* resource manager calls */
#include <infoseg.h>          /* InfoSegGDT definition */
#include <dskinit.h>          /* init request packet structure definitions */
#include <string.h>           /* string functions */

#include "parregs.h"          /* register definitions */
#include "partype.h"          /* typedefs */
#include "parstate.h"         /* states for state machine */
#include "parconst.h"         /* defines */
#include "parioctl.h"         /* parallel ioctl definitions and structures */
#include "parproto.h"         /* function prototypes */
#include "parextrn.h"         /* external data declarations */

