/* SCCSID = "src/dev/usb/COM/COMEXTRN.H, usb, c.basedd 98/10/26" */
/*
*   Licensed Material -- Property of IBM
*
*   (c) Copyright IBM Corp. 1998  All Rights Reserved
*/
/************************** START OF SPECIFICATIONS ***************************/
/*                                                                            */
/*   SOURCE FILE NAME:  COMEXTRN.H                                            */
/*                                                                            */
/*   DESCRIPTIVE NAME:  USB Communication Device Class Driver                 */
/*                      external data declarations                            */
/*                                                                            */
/*   FUNCTION: This module is the USB Communication Device Class Driver       */
/*             external data declarations include file. See comdata.c         */
/*             for the data items being externalized.                         */
/*                                                                            */
/*   NOTES:                                                                   */
/*      DEPENDENCIES: None                                                    */
/*      RESTRICTIONS: None                                                    */
/*                                                                            */
/*   ENTRY POINTS:  None                                                      */
/*                                                                            */
/*   EXTERNAL REFERENCES:  None                                               */
/*                                                                            */
/* Change Log                                                                 */
/*                                                                            */
/*  Mark    yy/mm/dd  Programmer      Comment                                 */
/*  ----    --------  ----------      -------                                 */
/*          98/10/26  LR                                                      */
/*                                                                            */
/**************************** END OF SPECIFICATIONS ***************************/

#ifdef   DEBUG
extern   USHORT   gCOMMsg;  // debug message level
#endif

extern char gDDName[];
extern char gDDDesc[];
extern char gVendorID[];
extern char gAdapterName[];

extern   DRIVERSTRUCT   gDriverStruct;
extern   ADAPTERSTRUCT  gAdapterStruct;

extern   HDRIVER        ghDriver;
extern   HADAPTER       ghAdapter;

extern   PFN            Device_Help;

extern   IDCTABLE       gIDCTable;
extern   PUSBIDCEntry   gpUSBDIDC;
extern   USHORT         gdsUSBDIDC;

extern BYTE           gInitDataStart;
extern USHORT         gVerbose;
extern USHORT         gMessageIDs[MAX_INIT_MESSAGE_COUNT];
extern PSZ            gVMessages[];
extern USHORT         gMessageCount;

extern COMInfo    gCOM;
extern CHAR       gCOMn[];
extern DeviceList gMDM[];
extern UCHAR      gNoOfMDMs;


